#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N=1e5+45;
ll t,n[6],m[6],a[N],b[N],i,j,k,p[N],brojac[N];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>t;
    for(i=1;i<=t;i++)
    {
        cin>>n[i]>>m[i];
        for(j=1;j<=n[i];j++) cin>>a[j];
        for(k=1;k<=m[i];k++) cin>>b[k];
        brojac[i]=1;
    }
    for(i=1;i<=t;i++)
    {
        if(n[i]==2)
        {
            p[i]=a[2]-a[1];
            for(k=1;k<=m[i];k++)
            {
                if((b[k]-a[1])%p[i]==0) brojac[i]=0;
            }
        }
    }
    for(i=1;i<=t;i++)
    {
        cout<<brojac[i]<<endl;
    }
    return 0;
}